#include <hmg.ch>


DECLARE WINDOW VideoManager


*-------------------------
FUNCTION FILTER_VIDEO()
*-------------------------

   SELECT FILTER
   GO TOP
 
  
   DEFINE WINDOW Window_FilterVideo ;
      AT 0,0 ;
      WIDTH 500 HEIGHT 300 ;
      TITLE "Filterbedingungen fr Video-Medien" ;
      MODAL 
      
      ON KEY ESCAPE ACTION Window_FilterVideo.Release
      
* -------------------------------------      

   @ 35, 40 LABEL Lbl_Filter_LfdNr ;
		VALUE 'Cassetten-Nr.:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 

   @ 30, 150 TEXTBOX tbx_Filter_LfdNr ;
		WIDTH 040 ;
		FONT "ARIAL" SIZE 10 BOLD 
      
   @ 35, 210 LABEL Lbl_Filter_Medium ;
		VALUE 'des Original-Mediums' ;
		WIDTH 150;
		FONT "ARIAL" SIZE 10 


      
* -------------------------------------      

   @ 70, 40 LABEL Lbl_Zeitraum1 ;
		VALUE 'Zeitraum von:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 
 

   @ 65, 150 TEXTBOX tbx_Filter_Von ;
		WIDTH 080 ;
		FONT "ARIAL" SIZE 10 BOLD ;
      INPUTMASK '99.99.9999' ;
      RIGHTALIGN 

      

   @ 70, 270 LABEL Lbl_Zeitraum2 ;
		VALUE 'Zeitraum bis:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 

   @ 70, 365 TEXTBOX tbx_Filter_Bis ;
		WIDTH 080 ;
		FONT "ARIAL" SIZE 10 BOLD ;
      INPUTMASK '99.99.9999' ;
      RIGHTALIGN  

      
* -------------------------------------      

   @ 105, 40 LABEL Lbl_Filter_Orig ;
		VALUE 'Original-Szene:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 

   @ 100, 150 TEXTBOX tbx_Filter_Orig ;
		WIDTH 300 ;
		FONT "ARIAL" SIZE 10 BOLD 

      
* -------------------------------------      

   @ 135, 40 LABEL Lbl_Filter_Proj ;
		VALUE 'Projekt-Name:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 

   @ 130, 150 TEXTBOX tbx_Filter_Proj ;
		WIDTH 300 ;
		FONT "ARIAL" SIZE 10 BOLD 

      
* -------------------------------------      

   @ 165, 40 LABEL Lbl_Filter_Titel ;
		VALUE 'Titel Videoclip:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 

   @ 160, 150 TEXTBOX tbx_Filter_Titel ;
		WIDTH 300 ;
		FONT "ARIAL" SIZE 10 BOLD 

      
* -------------------------------------      
      
		@ 220, 040 BUTTON Btn_VideoCancel ;
				CAPTION 'Vorgang abbrechen' ;
				PICTURE "Cancel_Red" LEFT ;
				ACTION   Window_FilterVideo.Release ;
				ToolTip "Keine Filterung durchfhren";
				WIDTH 200 ;
				HEIGHT 40 ;
				FONT "ARIAL" SIZE 10 BOLD 


		@ 220, 270 BUTTON Btn_Videofilter ;
				CAPTION 'Datenstze filtern' ;
				PICTURE "Save" LEFT ;
				ACTION   Filter_Set() ;
				ToolTip "Datenstze entsprechend der Filterbedingung auswhlen";
				WIDTH 180 ;
				HEIGHT 40 ;
				FONT "ARIAL" SIZE 10 BOLD 
      
     
    END WINDOW 

   Window_FilterVideo.tbx_Filter_LfdNr.value  := FILTER->Su_Num    // Werte aus der Datenbank in die Controls laden
   Window_FilterVideo.tbx_Filter_Von.value   := FILTER->Su_Von
   Window_FilterVideo.tbx_Filter_Bis.value   := FILTER->Su_Bis
   Window_FilterVideo.tbx_Filter_Orig.value  := FILTER->Su_Orig 
   Window_FilterVideo.tbx_Filter_Proj.value  := FILTER->Su_Proj
   Window_FilterVideo.tbx_Filter_Titel.value := FILTER->Su_Titel
   
    
   Window_FilterVideo.Center

   Window_FilterVideo.Activate
   
RETURN NIL
   
 
 
*-------------------------
FUNCTION FILTER_SET()
*-------------------------

   SELECT FILTER

   FILTER->Su_Num  := Window_FilterVideo.tbx_Filter_LfdNr.value   // Werte der Controls in die Datenbank speichern
   FILTER->Su_Von  := Window_FilterVideo.tbx_Filter_Von.value
   FILTER->Su_Bis  := Window_FilterVideo.tbx_Filter_Bis.value
   FILTER->Su_Orig  := Window_FilterVideo.tbx_Filter_Orig.value
   FILTER->Su_Proj  := Window_FilterVideo.tbx_Filter_Proj.value
   FILTER->Su_Titel := Window_FilterVideo.tbx_Filter_Titel.value

   * --------------------------

	   su_dat1		   := CTOD(FILTER->Su_Von)
	   su_dat2		   := CTOD(FILTER->Su_Bis)
	   su_nr		   := VAL(FILTER->Su_Num)
	   su_quell		:= UPPER(ALLTRIM(FILTER->Su_Orig))
	   su_projekt 	:= UPPER(ALLTRIM(FILTER->Su_Proj))
	   su_clip 		:= UPPER(ALLTRIM(FILTER->Su_Titel))

	   Filterbedingung='.T.'
	   su_begriff=''
	   IF su_nr # 0
	    Filterbedingung=Filterbedingung+' .AND. Lfd_Nr = su_nr'
	    su_begriff=su_begriff+'&'+su_num  
	   ENDIF
	   IF MONTH(su_dat1)#0
	    Filterbedingung=Filterbedingung+'.AND.Datum>=su_dat1'
	    su_begriff=su_begriff+' >= '+DTOC(su_dat1)
	   ENDIF
	   IF MONTH(su_dat2)#0
	    Filterbedingung=Filterbedingung+'.AND.Datum<=su_dat2'
	    su_begriff=su_begriff+' <= '+DTOC(su_dat2)
	   ENDIF
	   IF .NOT.EMPTY(su_quell)
	    Filterbedingung=Filterbedingung+'.AND.su_quell$UPPER(QUELLSZENE)'
	    su_begriff=su_begriff+'&'+su_quell
	   ENDIF
	   IF .NOT.EMPTY(su_projekt)
	    Filterbedingung=Filterbedingung+'.AND.su_projekt$UPPER(PROJEKT)'
	    su_begriff=su_begriff+'&'+su_projekt
	   ENDIF
	   IF .NOT.EMPTY(su_clip)
	    Filterbedingung=Filterbedingung+'.AND.su_clip$UPPER(TITEL)'
	    su_begriff=su_begriff+'&'+su_clip
	   ENDIF
	  
   
   IF TestModus
      MSGINFO("Filterbedingung: " + Filterbedingung,"FILTER_SET()")
   ENDIF
 
 
 
 	SELECT VIDEOS
	SET FILTER TO
	GO TOP
   
   su_anz=0

   IF LEN(ALLTRIM(Filterbedingung)) > 3        &&-- Eingaben gemacht ??
	   DO WHILE .NOT. EOF()	&&-------------------
	     IF &Filterbedingung
	      su_anz = su_anz+1
	      REPLACE Select WITH .T.
	     ELSE
	      REPLACE Select WITH .F.
	     ENDIF
	     SKIP
	   ENDDO			&&-------------------

   ENDIF

	IF su_anz>0
	    SET FILTER TO Select
	    MSGINFO('Datenstze gefunden: '+ALLTRIM(STR(su_anz)),'Datenbank filtern ..')
       Window_FilterVideo.Release
       SELECT VIDEOS
       GO TOP
       VideoManager.Brs_VideoListe.Refresh
	ELSE
	    SELECT VIDEOS
       SET FILTER TO
	    IF LEN(ALLTRIM(Filterbedingung)) > 3   &&-- wurden Eingaben gemacht ??
	     MSGINFO('Keine Datenstze gefunden !','Datenbank filtern ..')
	    ENDIF
       SELECT FILTER
       GO TOP
	ENDIF

RETURN NIL


*----------------------------
FUNCTION FILTER_FREIGABE()
*----------------------------

   SELECT VIDEOS
   SET FILTER TO
   MSGINFO('Die Filterung wurde aufgehoben !','Datenbank freigeben ..')
   VideoManager.Brs_VideoListe.Refresh

RETURN NIL


