#include <hmg.ch>

DECLARE WINDOW VideoManager


*-------------------------------------
FUNCTION CREATE_TREE(Vid_AktRec)
*-------------------------------------

   SELECT VIDEOS
   Cass_Lfd_Nr     :=   VIDEOS->LFd_Nr

   // Tree lschen  
   VideoManager.Video_Tree.DeleteAllItems
   
   // Alle Datenstze 'Lfd_Nr' durchgehen und Tree-Items erzeugen
   SET FILTER TO ( VIDEOS->LFD_Nr == Cass_Lfd_Nr )
   
   GO TOP
      // Ausgangssituation
      CassSzene  := ' '
      CassClip   := ' '
      
      Akt_Root   := 0
      Last_Node  := 1   // -> verknpft mit Root
      Akt_Node   := 1   // -> verknpft mit letzter Quellszene
      ItemIndex   := 0   // LfdNr der Tree-Items
      
      // Root definieren 
      CassNo        :=   ALLTRIM(STR(VIDEOS->LFd_Nr))
      CassBezeichung  := 	ALLTRIM(VIDEOS->Cassette)
      CassFormat	    :=	ALLTRIM(VIDEOS->FORMAT)
      format_len   :=  LEN(CassFormat)
      CassFormat     :=  RIGHT(CassFormat,format_len-3)
      VideoManager.Video_Tree.AddItem( 'No. '+CassNo+ '   -   ' + CassBezeichung + SPACE(15) + '[ '+CassFormat+' ]' , Akt_Root , {'Filmspule'} )
      ItemIndex   := ItemIndex + 1
      Last_Node   := ItemIndex   // Root-Index
     
   DO WHILE .NOT. EOF()
      IF .NOT.(CassSzene == VIDEOS->Quellszene)
         CassSzene   := ALLTRIM(VIDEOS->Quellszene)
         CassDatum   := DTOC(VIDEOS->DATUM)
         VideoManager.Video_Tree.AddItem( 'Szene: [ '+ CassDatum +'  -  '+ CassSzene +' ]', Last_Node , {'Filmszene'} )
         ItemIndex   := ItemIndex + 1
         Akt_Node := ItemIndex
 
      ENDIF
      IF .NOT.(CassClip == VIDEOS->Titel)
         CassClip    := 	ALLTRIM(VIDEOS->Titel)
         CassProjekt  :=	'Projekt: [ '+ ALLTRIM(VIDEOS->PROJEKT) +' ]'
		 VideoManager.Video_Tree.AddItem( CassProjekt +'  ----->   ' + 'Videoclip: [ '+ CassClip +' ]', Akt_Node , {'VideoClip'} )
         ItemIndex   := ItemIndex + 1
      ENDIF
      SKIP
   ENDDO
   
   SET FILTER TO
   
   GO Vid_AktRec

RETURN NIL